<?php

namespace Smac\MessageBundle\Controller;

use Smac\MessageBundle\Document\Message;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\Security\Core\SecurityContext;
use Smac\MessageBundle\Form\MessageType;
use Symfony\Component\HttpFoundation\Response;

class ArchiveController extends Controller
{
    public function listAction()
    {
        $request = $this->getRequest();
        $session = $request->getSession();

        $proj = (int)$session->get('smac_context');

        $messages = $this->get('doctrine_mongodb')
            ->getManager()
            ->getRepository('SmacMessageBundle:Message')
            ->findClassified($proj);

        $em = $this->getDoctrine()->getManager();
        $categories = $em->getRepository('SmacProjectBundle:Category')->findFromProject($proj);
        $subcategories = $em->getRepository('SmacProjectBundle:Category')->findSubcategoriesFromProject($proj);
        $typologies = $em->getRepository('SmacProjectBundle:Typology')->findFromProject($proj);

        return $this->render(
            'SmacMessageBundle:Archive:list.html.twig',
            array(
                'messages' => $messages,
                'categories' => $this->objectToArray($categories),
                'subcategories' => $this->objectToArray($subcategories),
                'typologies' => $this->objectToArray($typologies)
            )
        );
    }

    private function objectToArray($obj)
    {
        $ret = array();
        foreach($obj as $elem)
        {
            $ret[$elem->getId()] = $elem->getName();
        }
        return $ret;
    }

    public function unclassifyAction()
    {
        $request = $this->getRequest();
        $form = $request->request;

        $mId = $form->get('message-id');

        $message = $this->get('doctrine_mongodb')
            ->getRepository('SmacMessageBundle:Message')
            ->find($mId);

        if (!$message) {
            throw $this->createNotFoundException('Mensaje no encontrado');
        }

        $dm = $this->get('doctrine_mongodb')->getManager();
        $message->setDateClassified(null);
        $message->setCategory(null);
        $message->setTypology(null);
        $dm->persist($message);
        $dm->flush();

        return new Response(json_encode(array('saved'=>true)), 200, array('Content-Type'=>'application/json'));
    }
}