<?php
namespace Smac\MessageBundle\Document;

use Doctrine\ODM\MongoDB\Mapping\Annotations as MongoDB;

/**
 * @MongoDB\Document(repositoryClass="Smac\MessageBundle\Document\MessageRepository")
 */
class Message
{
    const MESSAGE_SOURCE_MANUAL = 1;
    const MESSAGE_SOURCE_TWITTER = 2;
    const MESSAGE_SOURCE_FACEBOOK = 3;

    const MESSAGE_VISIBILITY_PUBLIC = 1;
    const MESSAGE_VISIBILITY_PRIVATE = 2;

    const MESSAGE_SATISFACTION_POSITIVE = 1;
    const MESSAGE_SATISFACTION_NEGATIVE = 2;
    const MESSAGE_SATISFACTION_NA = 3;

    /**
     * @MongoDB\Id
     */
    private $id;

    /**
     * @MongoDB\Date
     */
    private $dateCreated;

    /**
     * @MongoDB\Date
     */
    private $dateReg;

    /**
     * @MongoDB\Date
     */
    private $dateClassified;

    /**
     * @MongoDB\Int
     */
    private $source;

    /**
     * @MongoDB\String
     */
    private $username;

    /**
     * @MongoDB\String
     */
    private $user;

    /**
     * @MongoDB\Int
     */
    private $category;

    /**
     * @MongoDB\Int
     */
    private $subcategory;

    /**
     * @MongoDB\Int
     */
    private $typology;

    /**
     * @MongoDB\Int
     */
    private $visibility;

    /**
     * @MongoDB\Int
     */
    private $satisfaction;

    /**
     * @MongoDB\Int
     */
    private $efficiency;

    /**
     * @MongoDB\String
     */
    private $text;

    /**
     * @MongoDB\Int
     */
    private $project;

    /**
     * @MongoDB\String
     */
    private $raw;

    /**
     * Get id
     *
     * @return id $id
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set dateReg
     *
     * @param date $dateReg
     * @return \Message
     */
    public function setDateReg($dateReg)
    {
        $this->dateReg = $dateReg;
        return $this;
    }

    /**
     * Get dateReg
     *
     * @return date $dateReg
     */
    public function getDateReg()
    {
        return $this->dateReg;
    }

    /**
     * Set source
     *
     * @param int $source
     * @return \Message
     */
    public function setSource($source)
    {
        $this->source = $source;
        return $this;
    }

    /**
     * Get source
     *
     * @return int $source
     */
    public function getSource()
    {
        return $this->source;
    }

    /**
     * Set user
     *
     * @param string $user
     * @return \Message
     */
    public function setUser($user)
    {
        $this->user = $user;
        return $this;
    }

    /**
     * Get user
     *
     * @return string $user
     */
    public function getUser()
    {
        return $this->user;
    }

    /**
     * Set category
     *
     * @param int $category
     * @return \Message
     */
    public function setCategory($category)
    {
        $this->category = $category;
        return $this;
    }

    /**
     * Get category
     *
     * @return int $category
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * Set subcategory
     *
     * @param int $subcategory
     * @return \Message
     */
    public function setSubcategory($subcategory)
    {
        $this->subcategory = $subcategory;
        return $this;
    }

    /**
     * Get subcategory
     *
     * @return int $subcategory
     */
    public function getSubcategory()
    {
        return $this->subcategory;
    }

    /**
     * Set visibility
     *
     * @param int $visibility
     * @return \Message
     */
    public function setVisibility($visibility)
    {
        $this->visibility = $visibility;
        return $this;
    }

    /**
     * Get visibility
     *
     * @return int $visibility
     */
    public function getVisibility()
    {
        return $this->visibility;
    }

    /**
     * Set satisfaction
     *
     * @param int $satisfaction
     * @return \Message
     */
    public function setSatisfaction($satisfaction)
    {
        $this->satisfaction = $satisfaction;
        return $this;
    }

    /**
     * Get satisfaction
     *
     * @return int $satisfaction
     */
    public function getSatisfaction()
    {
        return $this->satisfaction;
    }

    /**
     * Set efficiency
     *
     * @param int $efficiency
     * @return \Message
     */
    public function setEfficiency($efficiency)
    {
        $this->efficiency = $efficiency;
        return $this;
    }

    /**
     * Get efficiency
     *
     * @return int $efficiency
     */
    public function getEfficiency()
    {
        return $this->efficiency;
    }

    /**
     * Set text
     *
     * @param string $text
     * @return \Message
     */
    public function setText($text)
    {
        $this->text = $text;
        return $this;
    }

    /**
     * Get text
     *
     * @return string $text
     */
    public function getText()
    {
        return $this->text;
    }

    /**
     * Set project
     *
     * @param int $project
     * @return \Message
     */
    public function setProject($project)
    {
        $this->project = $project;
        return $this;
    }

    /**
     * Get project
     *
     * @return int $project
     */
    public function getProject()
    {
        return $this->project;
    }

    /**
     * Set dateClassified
     *
     * @param date $dateClassified
     * @return \Message
     */
    public function setDateClassified($dateClassified)
    {
        $this->dateClassified = $dateClassified;
        return $this;
    }

    /**
     * Get dateClassified
     *
     * @return date $dateClassified
     */
    public function getDateClassified()
    {
        return $this->dateClassified;
    }

    /**
     * Set typology
     *
     * @param int $typology
     * @return self
     */
    public function setTypology($typology)
    {
        $this->typology = $typology;
        return $this;
    }

    /**
     * Get typology
     *
     * @return int $typology
     */
    public function getTypology()
    {
        return $this->typology;
    }

    /**
     * Set dateCreated
     *
     * @param date $dateCreated
     * @return self
     */
    public function setDateCreated($dateCreated)
    {
        $this->dateCreated = $dateCreated;
        return $this;
    }

    /**
     * Get dateCreated
     *
     * @return date $dateCreated
     */
    public function getDateCreated()
    {
        return $this->dateCreated;
    }

    /**
     * Set username
     *
     * @param string $username
     * @return self
     */
    public function setUsername($username)
    {
        $this->username = $username;
        return $this;
    }

    /**
     * Get username
     *
     * @return string $username
     */
    public function getUsername()
    {
        return $this->username;
    }

    /**
     * Set raw
     *
     * @param string $raw
     * @return self
     */
    public function setRaw($raw)
    {
        $this->raw = $raw;
        return $this;
    }

    /**
     * Get raw
     *
     * @return string $raw
     */
    public function getRaw()
    {
        return $this->raw;
    }
}
