<?php

namespace Smac\MessageBundle\Document;

use Doctrine\ODM\MongoDB\DocumentRepository;

class MessageRepository extends DocumentRepository
{
    public function findPendingForClassify($proj)
    {
        return $this->createQueryBuilder()
            ->sort('dateReg', 'ASC')
            ->field('project')->equals($proj)
            ->field('dateClassified')->exists(false)
            ->sort('dateCreated', 'desc')
            ->getQuery()
            ->execute();
    }

    public function findFromProject($proj)
    {
        return $this->createQueryBuilder()
            ->sort('dateReg', 'ASC')
            ->field('project')->equals($proj)
            //->limit(10)
            ->getQuery()
            ->execute();
    }

    public function findClassified($proj)
    {
        return $this->createQueryBuilder()
            ->sort('dateReg', 'ASC')
            ->field('project')->equals($proj)
            ->field('dateClassified')->exists(true)
//            ->limit(10)
            ->getQuery()
            ->execute();
    }

    public function findClassifiedBetweenDates($proj, $ini, $end)
    {
        return $this->createQueryBuilder()
            ->sort('dateReg', 'ASC')
            ->field('project')->equals($proj)
            ->field('dateClassified')->exists(true)
            ->field('dateClassified')->range($ini, $end)
            ->getQuery()
            ->execute();
    }
}