<?php
namespace Smac\MessageBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Smac\MessageBundle\Document\Message;

class MessageType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('user')
            ->add('text', 'textarea')
//            ->add(
//                'satisfaction',
//                'choice',
//                array(
//                    'choices' => array(
//                        Message::MESSAGE_SATISFACTION_POSITIVE => 'Positiva',
//                        Message::MESSAGE_SATISFACTION_NEGATIVE => 'Negativa',
//                        Message::MESSAGE_SATISFACTION_NA => 'No contesta'
//                    )
//                )
//            )
            ->add(
                'visibility',
                'choice',
                array(
                    'choices' => array(
                        Message::MESSAGE_VISIBILITY_PUBLIC => 'Publico',
                        Message::MESSAGE_VISIBILITY_PRIVATE => 'Privado'
                    )
                )
            )
            ->add(
                'source',
                'choice',
                array(
                    'choices' => array(
                        Message::MESSAGE_SOURCE_MANUAL => 'Manual',
                        Message::MESSAGE_SOURCE_TWITTER => 'Twitter',
                        Message::MESSAGE_SOURCE_FACEBOOK => 'Facebook'
                    )
                )
            );
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            array(
                'data_class' => 'Smac\MessageBundle\Document\Message'
            )
        );
    }

    public function getName()
    {
        return 'smac_messagebundle_messagetype';
    }
}
