$(document).ready(function(){

    /**
     * Clasificar mensaje
     */
    $('body').on('click', '.classify-message .classify .btn', function(e) {
        e.preventDefault();
        var ref = $(this);
        var message = $(this).closest('.classify-message');

        //si esta desactivado no avanza
        if($(this).hasClass('disabled'))
            return false;

        //si no ha seleccionado categoria no avanza
        var category = message.find('select[name="category"]');
        if (category.val()==0) {
            category.addClass('error');
            return false;
        } else {
            category.removeClass('error');
        }

        //si no ha seleccionado categoria no avanza
        var typology = message.find('select[name="typology"]');
        if (typology.val()==0) {
            typology.addClass('error');
            return false;
        } else {
            typology.removeClass('error');
        }

        var id = message.attr('data-id');
        var subcategory = message.find('select[name="subcategory"]');
        var genTicket = message.find('input[name="ticket"]');

        var data = [];
        data.push({'name':'message-id', 'value':id});
        data.push({'name':'category', 'value':category.val()});
        var attr = subcategory.attr('disabled');

        if (typeof attr !== 'undefined' && attr !== false && attr != 'disabled') {
            data.push({'name':'subcategory', 'value':subcategory.val()});
        }

        if (genTicket.is(':checked')) {
            data.push({'name':'ticket', 'value':1});
        }

        data.push({'name':'typology', 'value':typology.val()});

        $.ajax({
            type    : "POST",
            url     : Routing.generate('smac_message_update'),
            data    : data,
            beforeSend: function() {
                //ref.addClass('disabled');
                message.slideUp();
            },
            success : function(ret) {

            }
        });
    });

    /**
     * Sincronizar nuevos mensajes de Twitter
     */
    $('.sync-twitter').click(function(e){
        e.preventDefault();
        var btn = $(this);

        if(btn.hasClass('disabled'))
            return false;

        $.ajax({
            type    : "POST",
            url     : Routing.generate('smac_api_twitter_sync', {'type':'new'}),
            beforeSend: function() {
                btn.addClass('disabled');
            },
            success : function(ret) {
                btn.removeClass('disabled');
                if(ret.synced > 0) {
                    alert('Se han sincronizado '+ret.synced+' mensajes de Twitter');
                    $('.btn-refresh').trigger('click');
                } else {
                    alert('No se ha podido sincronizar ningún mensaje de Twitter');
                }
            }
        });
    });

    /**
     * Actualizar mensajes
     */
    $('.btn-refresh').click(function(e){
        e.preventDefault();
        var btn = $(this);

        if(btn.hasClass('disabled'))
            return false;

        $.ajax({
            type    : "POST",
            url     : Routing.generate('smac_message_classify_list'),
            beforeSend: function() {
                btn.addClass('disabled');
            },
            success : function(ret) {
                btn.removeClass('disabled');
                $('.classify-list').html(ret);

            }
        });
    });

    $('body').on('change', '.classify-category', function() {
        var select = $(this);
        var val = parseInt(select.val());
        var subselect = $(this).next('select');

        subselect.attr('disabled', 'disabled');
        if (val == 0) {
            //...
        } else {
            $.ajax({
                type    : "GET",
                url     : Routing.generate('smac_project_category_subcategories', {'id':val}),
                beforeSend: function() {
                    select.attr('disabled', 'disabled');
                },
                success : function(ret) {
                    select.removeAttr('disabled');
                    if (ret.length > 0) {
                        subselect.removeAttr('disabled');
                        subselect.children(":gt(0)").remove();
                        $.each(ret, function() {
                            subselect.append($("<option />").val(this.id).text(this.name));
                        });
                    } else {

                    }
                }
            });
        }


    });
});