<?php

namespace Smac\ProjectBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\Security\Core\SecurityContext;
use Symfony\Component\Security\Core\Exception\AccessDeniedException;
use Smac\ProjectBundle\Entity\Category;
use Symfony\Component\HttpFoundation\Response;
use Smac\ProjectBundle\Form\CategoryType;

class CategoryController extends Controller
{
    public function indexAction()
    {
        $em = $this->getDoctrine()->getManager();
        $request = $this->getRequest();
        $session = $request->getSession();

        $proj = $session->get('smac_context');

        $categories = $em->getRepository('SmacProjectBundle:Category')->findFromProject($proj);

        return $this->render(
            'SmacProjectBundle:Category:index.html.twig',
            array(
                'categories' => $categories
            )
        );
    }

    public function createAction()
    {
        $em = $this->getDoctrine()->getManager();
        $request = $this->getRequest();
        $session = $request->getSession();

        $proj = $session->get('smac_context');
        $project = $em->getRepository('SmacProjectBundle:Project')->find($proj);

        $categories = $em->getRepository('SmacProjectBundle:Category')->findFromProject($proj);

        if ($request->getMethod() == 'POST') {
            $em = $this->getDoctrine()->getManager();
            $form = $request->request;

            $category = new Category();

            $category->setName($form->get('name'));
            $category->setProject($project);

            if ($form->get('parent')) {
                $parent = $em->getRepository('SmacProjectBundle:Category')->find($form->get('parent'));
                $category->setParentCategory($parent);
            }

            $em->persist($category);
            $em->flush();

            $this->get('session')->getFlashBag()->add(
                'success',
                'Categoria creada correctamente'
            );

            return $this->redirect($this->generateUrl('smac_project_category_index'));
        }

        return $this->render(
            'SmacProjectBundle:Category:create.html.twig',
            array(
                'categories' => $categories
            )
        );
    }

    public function subcategoriesAction($id)
    {
        $em = $this->getDoctrine()->getManager();
        $subcategories = $em->getRepository('SmacProjectBundle:Category')->findSubcategories($id, 'array');
        return new Response(json_encode($subcategories), 200, array('Content-Type'=>'application/json'));
    }
}