<?php

namespace Smac\ProjectBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\Security\Core\SecurityContext;
use Symfony\Component\Security\Core\Exception\AccessDeniedException;

class ContextController extends Controller
{
    public function listAction()
    {
        $user = $this->get('security.context')->getToken()->getUser();
        $em = $this->getDoctrine()->getManager();

        $projects = $em->getRepository('SmacProjectBundle:Project')->findProjectsByUser($user);

        return $this->render(
            'SmacProjectBundle:Context:list.html.twig',
            array(
                'projects'=>$projects
            )
        );
    }

    public function toggleAction($id)
    {
        $request = $this->getRequest();
        $session = $request->getSession();
        $em = $this->getDoctrine()->getManager();

        $user = $this->get('security.context')->getToken()->getUser();

        //@todo: mirar si el usuario tiene permisos para lo que pide

        //asignar session por proyecto seleccionado + roles
        $roles = $em->getRepository('SmacProjectBundle:RelProjectUser')->getRoles($id, $user);

        if ($roles) {
            $project = $em->getRepository('SmacProjectBundle:Project')->find($id);
            $session->set('smac_roles', $roles);
            $session->set('smac_context', $id);
            $session->set('smac_context_name', $project->getName());
        } else {
            throw new AccessDeniedException('No tienes los permisos necesarios');
        }

        //redirigir a home "neutral"
        return $this->redirect($this->generateUrl('smac_project_home'));
    }
}
