<?php

namespace Smac\ProjectBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\Security\Core\SecurityContext;
use Smac\ProjectBundle\Entity\Project;
use Smac\ProjectBundle\Form\ProjectType;
use Symfony\Component\HttpFoundation\File\UploadedFile;
use Smac\ProjectBundle\Entity\RelProjectUser;

class DefaultController extends Controller
{
    public function homeAction()
    {
        return $this->render('SmacProjectBundle:Default:home.html.twig');
    }

    public function createAction()
    {
        $request = $this->getRequest();

        $project = new Project();
        $form = $this->createForm(new ProjectType(), $project);

        if ($request->getMethod() == 'POST') {
            $form->bind($request);
            if ($form->isValid()) {

                $em = $this->getDoctrine()->getManager();

                //seteamos proyecto
                $user = $this->get('security.context')->getToken()->getUser();
                $project->setUser($user);
                //@todo: upload de logo

                //seteamos permisos
                $rel = new RelProjectUser();
                $rel->setUser($user);
                $rel->setProject($project);
                $rel->setRoles(RelProjectUser::ROLE_MANAGER);

                //guardamos
                $em->persist($project);
                $em->persist($rel);
                $em->flush();

                //return $this->redirect($this->generateUrl('smac_project_create_landing'));
                return $this->redirect($this->generateUrl('smac_project_context_toggle', array('id'=>$project->getId())));
            }
        }

        return $this->render(
            'SmacProjectBundle:Default:create.html.twig',
            array(
                'form' => $form->createView()
            )
        );
    }

//    public function createLandingAction()
//    {
//        //@todo: toggle + info
//
//        return $this->render('SmacProjectBundle:Default:create_landing.html.twig');
//    }

    public function editAction()
    {
        $em = $this->getDoctrine()->getManager();
        $request = $this->getRequest();
        $session = $request->getSession();

        $id = $session->get('smac_context');

        if (!$id) {
            throw $this->createNotFoundException('El proyecto no existe');
        }

        $project = $em->getRepository('SmacProjectBundle:Project')->find($id);

        if (!$project) {
            throw $this->createNotFoundException('El proyecto no existe');
        }

        //@todo: mirar si tiene permisos de gestor

        $form = $this->createForm(new ProjectType(), $project);

        if ($request->getMethod() == 'POST') {
            $form->bind($request);
            if ($form->isValid()) {

                $em = $this->getDoctrine()->getManager();

                //guardamos
                $em->persist($project);
                $em->flush();

                return $this->redirect($this->generateUrl('smac_project_edit_landing'));
            }
        }

        return $this->render(
            'SmacProjectBundle:Default:edit.html.twig',
            array(
                'project' => $project,
                'form' => $form->createView()
            )
        );
    }

    public function editLandingAction()
    {
        return $this->render('SmacProjectBundle:Default:edit_landing.html.twig');
    }
}
