<?php

namespace Smac\ProjectBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\Security\Core\SecurityContext;
use Symfony\Component\Security\Core\Exception\AccessDeniedException;
use Smac\ProjectBundle\Entity\Typology;
use Symfony\Component\HttpFoundation\Response;
use Smac\ProjectBundle\Form\TypologyType;

class TypologyController extends Controller
{
    public function indexAction()
    {
        $em = $this->getDoctrine()->getManager();
        $request = $this->getRequest();
        $session = $request->getSession();

        $proj = $session->get('smac_context');

        $typologies = $em->getRepository('SmacProjectBundle:Typology')->findFromProject($proj);

        return $this->render(
            'SmacProjectBundle:Typology:index.html.twig',
            array(
                'typologies' => $typologies
            )
        );
    }

    public function createAction()
    {
        $em = $this->getDoctrine()->getManager();
        $request = $this->getRequest();
        $session = $request->getSession();

        $proj = $session->get('smac_context');
        $project = $em->getRepository('SmacProjectBundle:Project')->find($proj);

        $typology = new Typology();
        $form = $this->createForm(new TypologyType(), $typology);

        if ($request->getMethod() == 'POST') {
            $form->bind($request);
            if ($form->isValid()) {

                $em = $this->getDoctrine()->getManager();

                $typology->setProject($project);

                $em->persist($typology);
                $em->flush();

                $this->get('session')->getFlashBag()->add(
                    'success',
                    'Tiplogía creada correctamente'
                );

                return $this->redirect($this->generateUrl('smac_project_typology_index'));
            }
        }

        return $this->render(
            'SmacProjectBundle:Typology:create.html.twig',
            array(
                'form' => $form->createView()
            )
        );
    }
}