<?php

namespace Smac\ProjectBundle\Entity;

use Doctrine\ORM\EntityRepository;

/**
 * CategoryRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class CategoryRepository extends EntityRepository
{
    public function findFromProject($proj, $type = '')
    {
        $em = $this->getEntityManager();

        $query = $em->createQuery(
          'SELECT
              c, cc
          FROM
              SmacProjectBundle:Category c
          LEFT JOIN
              c.childrenCategories cc
          WHERE
              c.project = :proj
              AND c.parentCategory IS NULL'
        );
        $query->setParameter('proj', $proj);

        if (!$type) {
            return $query->getResult();
        } elseif ($type=='array') {
            return $query->getArrayResult();
        }
    }

    public function findSubcategoriesFromProject($proj, $type = '')
    {
        $em = $this->getEntityManager();

        $query = $em->createQuery(
            'SELECT
                c, cc
            FROM
                SmacProjectBundle:Category c
            LEFT JOIN
                c.childrenCategories cc
            WHERE
                c.project = :proj
                AND c.parentCategory IS NOT NULL'
        );
        $query->setParameter('proj', $proj);

        if (!$type) {
            return $query->getResult();
        } elseif ($type=='array') {
            return $query->getArrayResult();
        }
    }

    public function findSubcategories($id, $type = '')
    {
        $em = $this->getEntityManager();

        $query = $em->createQuery(
            'SELECT
                c
            FROM
                SmacProjectBundle:Category c
            WHERE
                c.parentCategory = :cat'
        );
        $query->setParameter('cat', $id);

        if (!$type) {
            return $query->getResult();
        } elseif ($type=='array') {
            return $query->getArrayResult();
        }
    }
}
