<?php

namespace Smac\ProjectBundle\Entity;

use Doctrine\ORM\EntityRepository;
use Smac\UserBundle\Entity\User;

/**
 * ProjectRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class ProjectRepository extends EntityRepository
{
    /**
     * @param User $user
     * @return array
     */
    public function findProjectsByUser(User $user)
    {
        $em = $this->getEntityManager();

        $query = $em->createQuery(
            'SELECT
                p
            FROM
                SmacProjectBundle:Project p
            JOIN
                p.relUsers r
            WHERE
                r.user = :user'
        );
        $query->setParameter('user', $user);

        return $query->getResult();
    }

    /**
     * @param int $proj
     * @return array
     */
    public function findAttachedUsers($proj)
    {
        $em = $this->getEntityManager();

        $query = $em->createQuery(
            'SELECT
                r, u
            FROM
              SmacProjectBundle:RelProjectUser r
            JOIN
              r.user u
            WHERE
              r.project = :proj'
        );
        $query->setParameter('proj', $proj);

        return $query->getResult();
    }

    /**
     * @param int $proj
     * @return array
     */
    public function findElegibleUsers($proj)
    {
        $em = $this->getEntityManager();

        $query = $em->createQuery(
            'SELECT
                u
            FROM
              SmacUserBundle:User u
            WHERE
              u.id NOT IN(
                  SELECT
                    us.id
                  FROM
                    SmacProjectBundle:RelProjectUser re
                  JOIN
                    re.user us
                  WHERE
                    re.project = :proj
              )'
        );

        $query->setParameter('proj', $proj);

        return $query->getResult();
    }
}
