<?php

namespace Smac\ProjectBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * Project
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="Smac\ProjectBundle\Entity\RelProjectUserRepository")
 */
class RelProjectUser
{
    const ROLE_MANAGER = "ROLE_MANAGER";
    const ROLE_ANALIST = "ROLE_ANALIST";
    const ROLE_CM = "ROLE_CM";
    const ROLE_CC = "ROLE_CC";//customer care, callcenter?

    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity="Smac\UserBundle\Entity\User", inversedBy="relProjects")
     * @ORM\JoinColumn(name="user_id", referencedColumnName="id")
     */
    private $user;

    /**
     * @ORM\ManyToOne(targetEntity="Smac\ProjectBundle\Entity\Project", inversedBy="relUsers")
     * @ORM\JoinColumn(name="project_id", referencedColumnName="id")
     */
    private $project;

    /**
     * @ORM\Column(name="roles", type="string", length=255, nullable=true)
     */
    private $roles;

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set roles
     *
     * @param string $roles
     * @return RelProjectUser
     */
    public function setRoles($roles)
    {
        $this->roles = $roles;
    
        return $this;
    }

    /**
     * Get roles
     *
     * @return string 
     */
    public function getRoles()
    {
        return $this->roles;
    }

    /**
     * Set user
     *
     * @param \Smac\UserBundle\Entity\User $user
     * @return RelProjectUser
     */
    public function setUser(\Smac\UserBundle\Entity\User $user = null)
    {
        $this->user = $user;
    
        return $this;
    }

    /**
     * Get user
     *
     * @return \Smac\UserBundle\Entity\User 
     */
    public function getUser()
    {
        return $this->user;
    }

    /**
     * Set project
     *
     * @param \Smac\ProjectBundle\Entity\Project $project
     * @return RelProjectUser
     */
    public function setProject(\Smac\ProjectBundle\Entity\Project $project = null)
    {
        $this->project = $project;
    
        return $this;
    }

    /**
     * Get project
     *
     * @return \Smac\ProjectBundle\Entity\Project 
     */
    public function getProject()
    {
        return $this->project;
    }
}
