<?php

namespace Smac\TicketBundle\Entity;

use Doctrine\ORM\EntityRepository;

/**
 * TicketRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class TicketRepository extends EntityRepository
{
    public function findFromProject($proj, $status = Ticket::TICKET_STATUS_OPENED)
    {
        $em = $this->getEntityManager();

        $query = $em->createQuery(
            'SELECT
                t
            FROM
                SmacTicketBundle:Ticket t
            LEFT JOIN
                t.threads tt
            WHERE
                t.project = :proj
                AND t.status = :status'
        );
        $query->setParameter('proj', $proj);
        $query->setParameter('status', $status);

        return $query->getResult();
    }

    public function findWithComments($id)
    {
        $em = $this->getEntityManager();

        $query = $em->createQuery(
            'SELECT
                t, tt
            FROM
                SmacTicketBundle:Ticket t
            LEFT JOIN
              t.threads tt WITH tt.type = :ttype
            WHERE
                t.id = :id'
        );
        $query->setParameter('id', $id);
        $query->setParameter('ttype', TicketThread::TYPE_COMMENT);

        return $query->getSingleResult();
    }
}
