<?php
namespace Smac\UserBundle\DataFixtures\ORM;

use Doctrine\Common\DataFixtures\FixtureInterface;
use Doctrine\Common\Persistence\ObjectManager;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

use Smac\UserBundle\Entity\User;

class LoadUserData implements FixtureInterface, ContainerAwareInterface
{
    private $container;

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    /**
    * {@inheritDoc}
    */
    public function load(ObjectManager $manager)
    {
        for ($i=1; $i<=500; $i++) {
            $user = new User();
            $plainPwd = 'usuario'.$i;
            $salt = md5(time());
            $encoder = $this->container->get('security.encoder_factory')
                ->getEncoder($user);
            $password = $encoder->encodePassword($plainPwd, $salt);
            $user->setPassword($password);
            $user->setSalt($salt);
            $user->setEmail('usuario'.$i.'@smac.es');
            $user->setName('nombre'.$i);
            $user->setSurname('apellido'.$i);

            $manager->persist($user);
        }
        $manager->flush();
    }
}