<?php

namespace Smac\UserBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class UserType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('name', 'text', array('label'=>'Nombre'))
            ->add('surname', 'text', array('label'=>'Apellido'))
            ->add('email', 'email')
            ->add(
                'password',
                'repeated',
                array(
                    'type' => 'password',
                    'invalid_message' => 'Las dos contraseñas deben coincidir',
                    'options' => array('label' => 'Contraseña')
                )
            );
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            array(
                'data_class' => 'Smac\UserBundle\Entity\User'
            )
        );
    }

    public function getName()
    {
        return 'smac_userbundle_usertype';
    }
}